-- Inventory Script for CS2D by Yasday ( V1.0, Final )

fromx = 77 -- pixels
fromy = 25 -- pixels
REFRESHTIME = 10 -- milliseconds
MONEYVARIABLE = money -- money variable ( if any )

inv = {}
if luaload_use == true then inv.dir = self.directory else error("loaload.lua is needed to run this file!") return end
inv.gfxdir = inv.dir .. "gfx/"

dofile(inv.dir .. self.name .. "_items.lua")
for i, v in ipairs(inv.items) do
	if not v.img then v.img = "noicon.png" end
	v.img = inv.gfxdir .. "icons/" .. v.img
	local f = io.open(v.img, "r")
	if f == nil then
		v.img = inv.gfxdir .. "icons/noicon.png"
	end
end

local f = io.open("sys/servertransfer.lst", "a+")
local c = f:read("*a")
local s = ""
for i, v in ipairs(inv.items) do
	if not string.find(c, v.img) then
		if not string.find(s, v.img) then
			s = s .. v.img .. "\n"
		end
	end
end
if not string.find(c, inv.gfxdir .. "board.png") then
	s = s .. inv.gfxdir .. "board.png\n"
end
if not string.find(c, inv.gfxdir .. "next.png") then
	s = s .. inv.gfxdir .. "next.png\n"
end
if not string.find(c, inv.gfxdir .. "back.png") then
	s = s .. inv.gfxdir .. "back.png\n"
end
if not string.find(c, inv.gfxdir .. "close.png") then
	s = s .. inv.gfxdir .. "close.png\n"
end
f:write(s)
f:close()
if s ~= "" then parse("changemap " .. map("name")) end

dofile(inv.dir .. self.name .. "_adminmenu.lua")
inv.money = MONEYVARIABLE


_addhook = addhook
inv.openinvhook = {}
inv.images = {}
inv.cursor = {}
inv.oinv = {}

addhook = function(s, a, p)
	if s == "openinv" then
		table.insert(inv.openinvhook, a)
	else
		_addhook(s, a, p or 0)
	end
end

inv.callopeninvhook = function(id, sel)
	for i, v in ipairs(inv.openinvhook) do
		loadstring(v .. "(" .. id .. ", " .. sel .. ")")
	end
end

dostring = function(s)
	loadstring(s)()
end

function delay(t, s)
	timer(t, "dostring", tostring(s))
end

inv.nton = function(id)
	return inv.items[id] and inv.items[id].name or nil
end

inv.ntoi = function(id)
	if not id then return end
	if type(id) == "number" then return id end
	for i = 1, table.maxn(inv.items) + 1, 1 do
		if inv.items[i] then
			if inv.items[i].name:lower() == id:lower() then
				return i
			end
		end
	end
end

inv.is = function(id, i)
	for l = 1, table.maxn(inv.inv[id]) + 1, 1 do
		if inv.inv[id][l] then
			local v = inv.inv[id][l]
			if v[1] == i then
				return l
			end
		end
	end
end

inv.isnextfree = function(id)
	for i = 1, table.maxn(inv.inv[id]) + 1, 1 do
		if inv.inv[id][i] == nil then
			return i
		end
	end
end

inv.place = function(id, i, c)
	c = c or 1
	if type(i) == "string" then
		i = inv.ntoi(i)
	end
	if not inv.items[i] then return end
	if inv.is(id, i) then
		inv.inv[id][inv.is(id, i)] = {inv.inv[id][inv.is(id, i)][1], inv.inv[id][inv.is(id, i)][2] + c}
	else
		inv.inv[id][inv.isnextfree(id)] = {i, c}
	end
	msg2(id, "000238118Item \"" .. inv.nton(i) .. " (" .. c .. ")\" was placed in your inventory.")
end

inv.callinvopenhook = function(id, sel)
	for i, v in ipairs(inv.openinvhook) do
		dostring(v .. "(" .. id .. ", " .. sel .. ")")
	end
end

inv.invclose = function(id)
	if inv.oinv[id] ~= true then return end
	inv.oinv[id] = false
	for i = 1, 16, 1 do
		freeimage(inv.images[id][i][1])
	end
	for i = 0, 14, 1 do
		parse("hudtxt2 " .. id .. " " .. i .. " \"\"")
	end
end

inv.create_hudtxt = function(id, m)
	parse("hudtxt2 " .. id .. " 0 \"000238118" .. m[1] .. "\" " .. fromx + 20 .. " " ..  fromy + 7)
	parse("hudtxt2 " .. id .. " 1 \"000238118" .. m[2] .. "\" " .. fromx + 79 .. " " ..  fromy + 106)
	parse("hudtxt2 " .. id .. " 2 \"000238118" .. m[3] .. "\" " .. fromx + 152 .. " " ..  fromy + 106)
	parse("hudtxt2 " .. id .. " 3 \"000238118" .. m[4] .. "\" " .. fromx + 230 .. " " ..  fromy + 106)
	parse("hudtxt2 " .. id .. " 4 \"000238118" .. m[5] .. "\" " .. fromx + 305 .. " " ..  fromy + 106)
	parse("hudtxt2 " .. id .. " 5 \"000238118" .. m[6] .. "\" " .. fromx + 79 .. " " ..  fromy + 192)
	parse("hudtxt2 " .. id .. " 6 \"000238118" .. m[7] .. "\" " .. fromx + 152 .. " " ..  fromy + 192)
	parse("hudtxt2 " .. id .. " 7 \"000238118" .. m[8] .. "\" " .. fromx + 230 .. " " ..  fromy + 192)
	parse("hudtxt2 " .. id .. " 8 \"000238118" .. m[9] .. "\" " .. fromx + 305 .. " " ..  fromy + 192)
	parse("hudtxt2 " .. id .. " 9 \"000238118" .. m[10] .. "\" " .. fromx + 79 .. " " ..  fromy + 280)
	parse("hudtxt2 " .. id .. " 10 \"000238118" .. m[11] .. "\" " .. fromx + 152 .. " " ..  fromy + 279)
	parse("hudtxt2 " .. id .. " 11 \"000238118" .. m[12] .. "\" " .. fromx + 230 .. " " ..  fromy + 279)
	parse("hudtxt2 " .. id .. " 12 \"000238118" .. m[13] .. "\" " .. fromx + 305 .. " " ..  fromy + 279)
	parse("hudtxt2 " .. id .. " 13 \"000238118" .. m[14] .. "\" " .. fromx + 70 .. " " ..  fromy + 356)
	parse("hudtxt2 " .. id .. " 14 \"000238118" .. m[15] .. "\" " .. fromx + 363 .. " " ..  fromy + 356)
end

inv.open_inv = function(id, s)
	inv.oinv[id] = true
	local m = s:toTable(",")
	inv.create_hudtxt(id, m)
	inv.images[id][1] = { image(inv.gfxdir .. "board.png", fromx + 243, fromy + 201, 2, id) }
	inv.images[id][2] = { image(inv.items[inv.ntoi(m[2]) or 0].img, fromx + 115, fromy + 81, 2, id), function(id)
		local c = 1 + inv.page[id] * 12 - 12
		if inv.inv[id][c] and inv.inv[id][c][1] then
			local x = inv.cursor[id].x
			local y = inv.cursor[id].y
			if x >= 97 + fromx and y >= 63 + fromy and x <= 133 + fromx and y <= 98 + fromy then
				imagescale(inv.images[id][2][1], 1.5, 1.5)
				if inv.cursor[id].click == true then
					inv.invclose(id)
					inv.callinvopenhook(id, 1)
				end
			else
				imagescale(inv.images[id][2][1], 1, 1)
			end
		end
	end }
	inv.images[id][3] = { image(inv.items[inv.ntoi(m[3]) or 0].img, fromx + 191, fromy + 81, 2, id), function(id)
		local c = 2 + inv.page[id] * 12 - 12
		if inv.inv[id][c] and inv.inv[id][c][1] then
			local x = inv.cursor[id].x
			local y = inv.cursor[id].y
			if x >= 173 + fromx and y >= 63 + fromy and x <= 208 + fromx and y <= 98 + fromy then
				imagescale(inv.images[id][3][1], 1.5, 1.5)
				if inv.cursor[id].click == true then
					inv.invclose(id)
					inv.callinvopenhook(id, 2)
				end
			else
				imagescale(inv.images[id][3][1], 1, 1)
			end
		end
	end }
	inv.images[id][4] = { image(inv.items[inv.ntoi(m[4]) or 0].img, fromx + 267, fromy + 81, 2, id), function(id)
		local c = 3 + inv.page[id] * 12 - 12
		if inv.inv[id][c] and inv.inv[id][c][1] then
			local x = inv.cursor[id].x
			local y = inv.cursor[id].y
			if x >= 250 + fromx and y >= 63 + fromy and x <= 284 + fromx and y <= 98 + fromy then
				imagescale(inv.images[id][4][1], 1.5, 1.5)
				if inv.cursor[id].click == true then
					inv.invclose(id)
					inv.callinvopenhook(id, 3)
				end
			else
				imagescale(inv.images[id][4][1], 1, 1)
			end
		end
	end }
	inv.images[id][5] = { image(inv.items[inv.ntoi(m[5]) or 0].img, fromx + 343, fromy + 81, 2, id), function(id)
		local c = 4 + inv.page[id] * 12 - 12
		if inv.inv[id][c] and inv.inv[id][c][1] then
			local x = inv.cursor[id].x
			local y = inv.cursor[id].y
			if x >= 325 + fromx and y >= 63 + fromy and x <= 360 + fromx and y <= 98 + fromy then
				imagescale(inv.images[id][5][1], 1.5, 1.5)
				if inv.cursor[id].click == true then
					inv.invclose(id)
					inv.callinvopenhook(id, 4)
				end
			else
				imagescale(inv.images[id][5][1], 1, 1)
			end
		end
	end }
	inv.images[id][6] = { image(inv.items[inv.ntoi(m[6]) or 0].img, fromx + 115, fromy + 167, 2, id), function(id)
		local c = 5 + inv.page[id] * 12 - 12
		if inv.inv[id][c] and inv.inv[id][c][1] then
			local x = inv.cursor[id].x
			local y = inv.cursor[id].y
			if x >= 97 + fromx and y >= 149 + fromy and x <= 132 + fromx and y <= 184 + fromy then
				imagescale(inv.images[id][6][1], 1.5, 1.5)
				if inv.cursor[id].click == true then
					inv.invclose(id)
					inv.callinvopenhook(id, 5)
				end
			else
				imagescale(inv.images[id][6][1], 1, 1)
			end
		end
	end }
	inv.images[id][7] = { image(inv.items[inv.ntoi(m[7]) or 0].img, fromx + 191, fromy + 167, 2, id), function(id)
		local c = 6 + inv.page[id] * 12 - 12
		if inv.inv[id][c] and inv.inv[id][c][1] then
			local x = inv.cursor[id].x
			local y = inv.cursor[id].y
			if x >= 174 + fromx and y >= 149 + fromy and x <= 209 + fromx and y <= 184 + fromy then
				imagescale(inv.images[id][7][1], 1.5, 1.5)
				if inv.cursor[id].click == true then
					inv.invclose(id)
					inv.callinvopenhook(id, 6)
				end
			else
				imagescale(inv.images[id][7][1], 1, 1)
			end
		end
	end }
	inv.images[id][8] = { image(inv.items[inv.ntoi(m[8]) or 0].img, fromx + 267, fromy + 167, 2, id), function(id)
		local c = 7 + inv.page[id] * 12 - 12
		if inv.inv[id][c] and inv.inv[id][c][1] then
			local x = inv.cursor[id].x
			local y = inv.cursor[id].y
			if x >= 251 + fromx and y >= 149 + fromy and x <= 286 + fromx and y <= 184 + fromy then
				imagescale(inv.images[id][8][1], 1.5, 1.5)
				if inv.cursor[id].click == true then
					inv.invclose(id)
					inv.callinvopenhook(id, 7)
				end
			else
				imagescale(inv.images[id][8][1], 1, 1)
			end
		end
	end }
	inv.images[id][9] = { image(inv.items[inv.ntoi(m[9]) or 0].img, fromx + 343, fromy + 167, 2, id), function(id)
		local c = 8 + inv.page[id] * 12 - 12
		if inv.inv[id][c] and inv.inv[id][c][1] then
			local x = inv.cursor[id].x
			local y = inv.cursor[id].y
			if x >= 328 + fromx and y >= 149 + fromy and x <= 363 + fromx and y <= 184 + fromy then
				imagescale(inv.images[id][9][1], 1.5, 1.5)
				if inv.cursor[id].click == true then
					inv.invclose(id)
					inv.callinvopenhook(id, 8)
				end
			else
				imagescale(inv.images[id][9][1], 1, 1)
			end
		end
	end }
	inv.images[id][10] = { image(inv.items[inv.ntoi(m[10]) or 0].img, fromx + 115, fromy + 254, 2, id), function(id)
		local c = 9 + inv.page[id] * 12 - 12
		if inv.inv[id][c] and inv.inv[id][c][1] then
			local x = inv.cursor[id].x
			local y = inv.cursor[id].y
			if x >= 97 + fromx and y >= 236 + fromy and x <= 133 + fromx and y <= 271 + fromy then
				imagescale(inv.images[id][10][1], 1.5, 1.5)
				if inv.cursor[id].click == true then
					inv.invclose(id)
					inv.callinvopenhook(id, 9)
				end
			else
				imagescale(inv.images[id][10][1], 1, 1)
			end
		end
	end }
	inv.images[id][11] = { image(inv.items[inv.ntoi(m[11]) or 0].img, fromx + 191, fromy + 254, 2, id), function(id)
		local c = 10 + inv.page[id] * 12 - 12
		if inv.inv[id][c] and inv.inv[id][c][1] then
			local x = inv.cursor[id].x
			local y = inv.cursor[id].y
			if x >= 173 + fromx and y >= 236 + fromy and x <= 208 + fromx and y <= 271 + fromy then
				imagescale(inv.images[id][11][1], 1.5, 1.5)
				if inv.cursor[id].click == true then
					inv.invclose(id)
					inv.callinvopenhook(id, 10)
				end
			else
				imagescale(inv.images[id][11][1], 1, 1)
			end
		end
	end }
	inv.images[id][12] = { image(inv.items[inv.ntoi(m[12]) or 0].img, fromx + 267, fromy + 254, 2, id), function(id)
		local c = 11 + inv.page[id] * 12 - 12
		if inv.inv[id][c] and inv.inv[id][c][1] then
			local x = inv.cursor[id].x
			local y = inv.cursor[id].y
			if x >= 251 + fromx and y >= 236 + fromy and x <= 287 + fromx and y <= 271 + fromy then
				imagescale(inv.images[id][12][1], 1.5, 1.5)
				if inv.cursor[id].click == true then
					inv.invclose(id)
					inv.callinvopenhook(id, 11)
				end
			else
				imagescale(inv.images[id][12][1], 1, 1)
			end
		end
	end }
	inv.images[id][13] = { image(inv.items[inv.ntoi(m[13]) or 0].img, fromx + 343, fromy + 254, 2, id), function(id)
		local c = 12 + inv.page[id] * 12 - 12
		if inv.inv[id][c] and inv.inv[id][c][1] then
			local x = inv.cursor[id].x
			local y = inv.cursor[id].y
			if x >= 328 + fromx and y >= 236 + fromy and x <= 364 + fromx and y <= 271 + fromy then
				imagescale(inv.images[id][13][1], 1.5, 1.5)
				if inv.cursor[id].click == true then
					inv.invclose(id)
					inv.callinvopenhook(id, 12)
				end
			else
				imagescale(inv.images[id][13][1], 1, 1)
			end
		end
	end }
	inv.images[id][14] = { image(inv.gfxdir .. "back.png", fromx + 44.5, fromy + 367.5, 2, id), function(id)
		local x = inv.cursor[id].x
		local y = inv.cursor[id].y
		if x >= 31 + fromx and y >= 354 + fromy and x <= 55 + fromx and y <= 378 + fromy then
			imagescale(inv.images[id][14][1], 1.5, 1.5)
			if inv.cursor[id].click == true then
				inv.invclose(id)
				inv.callinvopenhook(id, -2)
			end
		else
			imagescale(inv.images[id][14][1], 1, 1)
		end
	end }
	inv.images[id][15] = { image(inv.gfxdir .. "next.png", fromx + 434.5, fromy + 367.5, 2, id), function(id)
		local x = inv.cursor[id].x
		local y = inv.cursor[id].y
		if x >= 421 + fromx and y >= 354 + fromy and x <= 445 + fromx and y <= 378 + fromy then
			imagescale(inv.images[id][15][1], 1.5, 1.5)
			if inv.cursor[id].click == true then
				inv.invclose(id)
				inv.callinvopenhook(id, -1)
			end
		else
			imagescale(inv.images[id][15][1], 1, 1)
		end
	end }
	inv.images[id][16] = { image(inv.gfxdir .. "close.png", fromx + 461.5, fromy + 17.5, 2, id), function(id)
		local x = inv.cursor[id].x
		local y = inv.cursor[id].y
		if x >= 445 + fromx and y >= 8 + fromy and x <= 476 + fromx and y <= 25 + fromy then
			imagescale(inv.images[id][16][1], 1.5, 1.5)
			if inv.cursor[id].click == true then
				inv.invclose(id)
				inv.callinvopenhook(id, 0)
			end
		else
			imagescale(inv.images[id][16][1], 1, 1)
		end
	end }
end

inv.show = function(id, p)
	local s = "Inventory Page " .. p
	for i = p * 12 - 11, p * 12 do
		if inv.inv[id][i] then
			local v = inv.inv[id][i]
			s = s .. "," .. inv.nton(v[1]) or ""
		else
			s = s .. ",No item"
		end
	end
	inv.page[id] = p
	inv.open_inv(id, s .. ",<<< Back,Next >>>")
end

inv.showplayers = function(id, p)
	local s = "Players Page " .. p
	for i = p * 7 - 6, p * 7 do
		if player(i, "exists") then
			s = s .. "," .. player(i, "name")
		else
			s = s .. ","
		end
	end
	inv.page[id] = p
	menu(id, s .. ",<<<|Back,Next|>>>")
end

inv.save = function(id)
	if id == 0 then for i = 1, #player(0, "table"), 1 do inv.save(player(0, "table")[i]) end return end
	local us = player(id, "usgn")
	if us > 0 then
		local s = ""
		local c = false
		for lines in io.lines(inv.dir .. "saves.sav") do
			local line = lines:toTable(":")
			if tonumber(line[1]) == us then
				local f = ""
				for i = 1, table.maxn(inv.inv[id]) + 1, 1 do
					local v = inv.inv[id][i]
					if v and inv.items[v[1]] then
						f = f .. tostring(v[1]) .. "," .. tostring(v[2]) .. ":"
					else
						f = f .. " :"
					end
				end
				s = s .. us .. ":" .. f .. "\n"
				c = true
			else
				s = s .. lines .. "\n"
			end
		end
		if c == true then
			local f = io.open(inv.dir .. "saves.sav", "w")
			f:write(s)
			f:close()
		else
			local x = ""
			for i = 1, table.maxn(inv.inv[id]) + 1, 1 do
				local v = inv.inv[id][i]
				if v then
					x = x .. tostring(v[1]) .. "," .. tostring(v[2]) .. ":"
				else
					x = x .. " :"
				end
			end
			x = us .. ":" .. x .. "\n"
			local f = io.open(inv.dir .. "saves.sav", "a")
			f:write(x)
			f:close()
		end
	end
end

inv.load = function(id)
	if id == 0 then for i = 1, #player(0, "table"), 1 do inv.load(player(0, "table")[i]) end return end
	local us = player(id, "usgn")
	if us > 0 then
		for lines in io.lines(inv.dir .. "saves.sav") do
			local line = lines:toTable(":")
			if tonumber(line[1]) == us then
				for i = 2, table.maxn(line) + 1, 1 do
					local v = line[i]
					if v ~= " " and v and inv.items[tonumber(v:toTable(",")[1])] then
						inv.inv[id][i - 1] = {tonumber(v:toTable(",")[1]), tonumber(v:toTable(",")[2])}
					else
						inv.inv[id][i - 1] = nil
					end
				end
				break
			end
		end
	end
end

inv.declick = function(id)
	inv.cursor[tonumber(id)].click = false
end

reqclda = function()
	reqcld(0, 0)
end

inv.inv = {}
inv.page = {}
inv.looks = {}

inv.join = function(id)
	inv.inv[id] = {}
	inv.page[id] = 0
	inv.looks[id] = 0
	inv.oinv[id] = false
	inv.images[id] = {}
	if inv.adm and inv.adm.join then inv.adm.join(id) end
	inv.load(id)
	if inv.items.join then inv.items.join(id) end
end
addhook([[join]], [[inv.join]])

inv.attack = function(id)
	if inv.oinv[id] == true then
		inv.cursor[id].click = true
		parse("setweapon " .. id .. " 50")
		timer(REFRESHTIME, "inv.declick", id)
	end
	if inv.items.attack then inv.items.attack(id) end
end
addhook([[attack]], [[inv.attack]])

inv.menu = function(id, men, sel)
	if men == "Players Page " .. inv.page[id] then
		if sel == 8 then
			if inv.page[id] > 1 then
				inv.showplayers(id, inv.page[id] - 1)
			else
				inv.showplayers(id, 5)
			end
		elseif sel == 9 then
			if inv.page[id] < 5 then
				inv.showplayers(id, inv.page[id] + 1)
			else
				inv.showplayers(id, 1)
			end
		elseif type(sel) == "number" and sel > 0 then
			local pl = sel + inv.page[id] * 7 - 7
			if id ~= pl then
				msg2(pl, "000238118" .. player(id, "name") .. " delivered you an item.")
				inv.place(pl, inv.inv[id][inv.looks[id]][1])
				msg2(id, "000238118Item \"" .. inv.items[inv.inv[id][inv.looks[id]][1]].name .. "\" delivered to " .. player(pl, "name") .. ".")
				if inv.inv[id][inv.looks[id]][2] > 1 then
					inv.inv[id][inv.looks[id]][2] = inv.inv[id][inv.looks[id]][2] - 1
				else
					inv.inv[id][inv.looks[id]] = nil
				end
				inv.looks[id] = 0
			else
				msg2(id, "000238118You shouldn't deliver items to yourself.")
				inv.showplayers(id, inv.page[id])
			end
		end
		return
	end
	if inv.looks[id] and inv.looks[id] ~= 0 then
		if inv.inv[id][inv.looks[id]] and inv.inv[id][inv.looks[id]][1] then
			if men == inv.items[inv.inv[id][inv.looks[id]][1]].name then
				if sel == 1 then
					inv.items[inv.inv[id][inv.looks[id]][1]].func(id)
					if inv.inv[id][inv.looks[id]][2] > 1 then
						inv.inv[id][inv.looks[id]][2] = inv.inv[id][inv.looks[id]][2] - 1
					else
						inv.inv[id][inv.looks[id]] = nil
					end
					inv.looks[id] = 0
				elseif sel == 2 then
					msg2(id, inv.items[inv.inv[id][inv.looks[id]][1]].desc)
				elseif sel == 3 then
					inv.showplayers(id, 1)
				end
				return
			end
		end
	end
	if inv.adm and inv.adm.menu then inv.adm.menu(id, men, sel) end
	if inv.items.menu then inv.items.menu(id, men, sel) end
	if inv.npc.menu then inv.npc.menu(id, men, sel) end
end
addhook([[menu]], [[inv.menu]])

inv.openinv = function(id, sel)
	if sel == -2 then
		if inv.page[id] > 1 then
			inv.show(id, inv.page[id] - 1)
		else
			inv.show(id, inv.page[id])
		end
	elseif sel == -1 then
		inv.show(id, inv.page[id] + 1)
	elseif type(sel) == "number" and sel > 0 then	
		inv.looks[id] = sel + inv.page[id] * 12 - 12
		menu(id, inv.items[inv.inv[id][inv.looks[id]][1]].name .. ",Use,Description,Deliver")
	end
	if inv.items.openinv then inv.items.openinv(id, sel) end
end
addhook([[openinv]], [[inv.openinv]])

inv.serveraction = function(id, a)
	if a == 1 then
		if inv.oinv[id] == false then inv.show(id, 1) end
	elseif a == 2 then 	print("X: " .. inv.cursor[id].x .. " Y: " .. inv.cursor[id].y)
	end
	if inv.adm and inv.adm.serveraction then inv.adm.serveraction(id, a) end
	if inv.items.serveraction then inv.items.serveraction(id, a) end
end
addhook([[serveraction]], [[inv.serveraction]])

timer(REFRESHTIME, "reqclda", "", 0)
inv.clientdata = function(id, mode, x, y)
	inv.cursor[id] = inv.cursor[id] or { }
	if mode == 0 then inv.cursor[id].x = x inv.cursor[id].y = y end
	if inv.oinv[id] == true then
		for i = 2, 16, 1 do
			if type(inv.images[id][i]) == "table" then inv.images[id][i][2](id, x, y) end
		end
	end
end
addhook([[clientdata]], [[inv.clientdata]])

inv.leave = function(id, r)
	inv.save(id)
	inv.inv[id] = {}
	inv.page[id] = 0
	inv.looks[id] = 0
	if inv.items.leave then inv.items.leave(id, r) end
	if inv.npc.leave then inv.npc.leave(id) end
end
addhook([[leave]], [[inv.leave]])

dofile(inv.dir .. self.name .. "_npc.lua")