inv.npc = {}

inv.npc.npcs = {
	[1] = {
		name = "Testor",
		img = "npc.png",
		x = 0,
		y = 0,
		rot = 135,
		trade = { "Apple|5000", { 9, 1000 } }
	}
}

for i, v in ipairs(inv.npc.npcs) do
	if not v.img then v.img = "npc.png" end
	v.img = inv.gfxdir .. "npc/" .. v.img
	for i, l in ipairs(v.trade) do
		if type(l) == "string" then
			for _, c in ipairs(l:toTable(",")) do
				v.trade[i] = { inv.ntoi(c:toTable("|")[1]), tonumber(c:toTable("|")[2]) }
			end
		end
	end
end

local f = io.open("sys/servertransfer.lst", "a+")
local c = f:read("*a")
local s = ""
for i, v in ipairs(inv.npc.npcs) do
	if not string.find(c, v.img) then
		if not string.find(s, v.img) then
			s = s .. v.img .. "\n"
		end
	end
end
f:write(s)
f:close()
if s ~= "" then parse("changemap " .. map("name")) end

for i, v in ipairs(inv.npc.npcs) do
	v.img = image(v.img, 0, 0, 3)
	imagepos(v.img, v.x * 32 + 16, v.y * 32 + 16, v.rot)
end

inv.npc.open = function(id, npc, p)
	inv.page[id] = p
	local s = npc.name .. " " .. inv.page[id]
	for i = 1, 7 do
		local k = i + inv.page[id] * 7 - 7
		print(npc.trade[k])
		if npc.trade[k] then
			s = s .. "," .. inv.nton(npc.trade[k][1]) .. "|" .. npc.trade[k][2]
		else
			s = s .. ","
		end
	end
	menu(id, s .. ",<<<|Back,Next|>>>")
end

inv.npc.use = function(id, x, y)
	for _, v in ipairs(inv.npc.npcs) do
		if math.sqrt((x - v.x) ^ 2 + (y - v.y) ^ 2) <= 2 then
			inv.page[id] = 1
			inv.npc.open(id, v, 1)
		end
	end
end
addhook([[use]], [[inv.npc.use]])

inv.npc.menu = function(id, men, sel)
	for _, npc in ipairs(inv.npc.npcs) do
		if men == npc.name .. " " .. inv.page[id] then
			if sel == 8 then
				if inv.page[id] > 1 then
					inv.npc.open(id, npc, inv.page[id] - 1)
				else
					inv.npc.open(id, npc, inv.page[id])
				end
			elseif sel == 9 then
				inv.npc.open(id, npc, inv.page[id] + 1)
			elseif type(sel) == "number" and sel > 0 then
				local k = sel + inv.page[id] * 7 - 7
				if inv.money then
					if inv.money[id] >= npc.trade[k][2] then
						inv.money[id] = inv.money[id] - npc.trade[k][2]
						inv.place(id, npc.trade[k][1])
					else
						msg2(id, "000238118Not enough money.")
					end
				else
					if player(id, "money") >= npc.trade[k][2] then
						parse("setmoney " .. id .. " " .. player(id, "money") - npc.trade[k][2])
						inv.place(id, npc.trade[k][1])
					else
						msg2(id, "000238118Not enough money.")
					end
				end
			end
			return
		end
	end
end

inv.npc.leave = function(id)
	inv.money[id] = nil
end