-- Inventory Script for CS2D by Yasday ( V0.5 )

inv = {}
if luaload_use == true then inv.dir = self.directory else error("loaload.lua is needed to run this file!") return end

dofile(inv.dir .. self.name .. "_items.lua")
dofile(inv.dir .. self.name .. "_adminmenu.lua")

dostring = function(s)
	loadstring(s)()
end

function delay(t, s)
	s = tostring(s)
	timer(t, "dostring", "" .. s)
end

inv.nton = function(id)
	return inv.items[id].name
end

inv.ntoi = function(id)
	for i = 1, table.maxn(inv.items) + 1, 1 do
		if inv.items[i] then
			local v = inv.items[i]
			if v.name == id then
				return i
			end
		end
	end
end

inv.is = function(id, i)
	for l = 1, table.maxn(inv.inv[id]) + 1, 1 do
		if inv.inv[id][l] then
			local v = inv.inv[id][l]
			if v[1] == i then
				return l
			end
		end
	end
end

inv.isnextfree = function(id)
	for i = 1, table.maxn(inv.inv[id]) + 1, 1 do
		if inv.inv[id][i] == nil then
			return i
		end
	end
end

inv.place = function(id, i, c)
	c = c or 1
	if type(i) == "string" then
		i = inv.ntoi(i)
	end
	if not inv.items[i] then return end
	if inv.is(id, i) then
		inv.inv[id][inv.is(id, i)] = {inv.inv[id][inv.is(id, i)][1], inv.inv[id][inv.is(id, i)][2] + c}
	else
		inv.inv[id][inv.isnextfree(id)] = {i, c}
	end
	msg2(id, "000238118Item \"" .. inv.nton(i) .. " (" .. c .. ")\" was placed in your inventory.")
end

inv.show = function(id, p)
	local s = "Inventory Page " .. p
	for i = p * 7 - 6, p * 7 do
		if inv.inv[id][i] then
			local v = inv.inv[id][i]
			s = s .. "," .. inv.nton(v[1]) .. "|" .. v[2]
		else
			s = s .. ","
		end
	end
	inv.page[id] = p
	menu(id, s .. ",<<<|Back,Next|>>>")
end

inv.showplayers = function(id, p)
	local s = "Players Page " .. p
	for i = p * 7 - 6, p * 7 do
		if player(i, "exists") then
			s = s .. "," .. player(i, "name")
		else
			s = s .. ","
		end
	end
	inv.page[id] = p
	menu(id, s .. ",<<<|Back,Next|>>>")
end

inv.inv = {}
inv.page = {}
inv.looks = {}

inv.join = function(id)
	local us = player(id, "usgn")
	inv.inv[id] = {}
	inv.page[id] = 0
	inv.looks[id] = 0
	if inv.adm and inv.adm.join then inv.adm.join(id) end
	if us > 0 then
		for lines in io.lines(inv.dir .. "saves.sav") do
			local line = lines:toTable(":")
			if tonumber(line[1]) == us then
				for i = 2, table.maxn(line) + 1, 1 do
					local v = line[i]
					if v ~= " " and v then
						inv.inv[id][i - 1] = {tonumber(v:toTable(",")[1]), tonumber(v:toTable(",")[2])}
					else
						inv.inv[id][i - 1] = nil
					end
				end
				break
			end
		end
	end
	if inv.items.join then inv.items.join(id) end
end
addhook([[join]], [[inv.join]])

inv.menu = function(id, men, sel)
	if men == "Inventory Page " .. inv.page[id] then
		if sel == 8 then
			if inv.page[id] > 1 then
				inv.show(id, inv.page[id] - 1)
			else
				inv.show(id, inv.page[id])
			end
		elseif sel == 9 then
			inv.show(id, inv.page[id] + 1)
		elseif type(sel) == "number" and sel > 0 then	
			inv.looks[id] = sel + inv.page[id] * 7 - 7
			menu(id, inv.items[inv.inv[id][inv.looks[id]][1]].name .. ",Use,Description,Deliver")
		end
		return
	elseif men == "Players Page " .. inv.page[id] then
		if sel == 8 then
			if inv.page[id] > 1 then
				inv.showplayers(id,inv.page[id] - 1)
			else
				inv.showplayers(id, 5)
			end
		elseif sel == 9 then
			if inv.page[id] < 5 then
				inv.showplayers(id,inv.page[id] + 1)
			else
				inv.showplayers(id, 1)
			end
		elseif type(sel) == "number" and sel > 0 then
			local pl = sel + inv.page[id] * 7 - 7
			if id ~= pl then
				msg2(pl, "000238118" .. player(id, "name") .. " delivered you an item.")
				inv.place(pl, inv.inv[id][inv.looks[id]][1])
				msg2(id, "000238118Item \"" .. inv.items[inv.inv[id][inv.looks[id]][1]].name .. "\" delivered to " .. player(pl, "name") .. ".")
				if inv.inv[id][inv.looks[id]][2] > 1 then
					inv.inv[id][inv.looks[id]][2] = inv.inv[id][inv.looks[id]][2] - 1
				else
					inv.inv[id][inv.looks[id]] = nil
				end
				inv.looks[id] = 0
			else
				msg2(id, "000238118You shouldn't deliver items to yourself.")
				inv.showplayers(id, inv.page[id])
			end
		end
		return
	end
	if inv.looks[id] and inv.looks[id] ~= 0 then
		if inv.inv[id][inv.looks[id]][1] then
			if men == inv.items[inv.inv[id][inv.looks[id]][1]].name then
				if sel == 1 then
					inv.items[inv.inv[id][inv.looks[id]][1]].func(id)
					if inv.inv[id][inv.looks[id]][2] > 1 then
						inv.inv[id][inv.looks[id]][2] = inv.inv[id][inv.looks[id]][2] - 1
					else
						inv.inv[id][inv.looks[id]] = nil
					end
					inv.looks[id] = 0
				elseif sel == 2 then
					msg2(id, inv.items[inv.inv[id][inv.looks[id]][1]].desc)
				elseif sel == 3 then
					inv.showplayers(id, 1)
				end
				return
			end
		end
	end
	if inv.adm and inv.adm.menu then inv.adm.menu(id, men, sel) end
	if inv.items.menu then inv.items.menu(id, men, sel) end
end
addhook([[menu]], [[inv.menu]])

inv.serveraction = function(id, a)
	if a == 1 then
		inv.show(id, 1)
	end
	if inv.adm and inv.adm.serveraction then inv.adm.serveraction(id, a) end
	if inv.items.serveraction then inv.items.serveraction(id, a) end
end
addhook([[serveraction]], [[inv.serveraction]])

inv.leave = function(id, r)
	local us = player(id, "usgn")
	if us > 0 then
		local s = ""
		local c = false
		for lines in io.lines(inv.dir .. "saves.sav") do
			local line = lines:toTable(":")
			if tonumber(line[1]) == us then
				local f = ""
				for i = 1, table.maxn(inv.inv[id]) + 1, 1 do
					local v = inv.inv[id][i]
					if v then
						f = f .. tostring(v[1]) .. "," .. tostring(v[2]) .. ":"
					else
						f = f .. " :"
					end
				end
				s = s .. us .. ":" .. f .. "\n"
				c = true
			else
				s = s .. lines .. "\n"
			end
		end
		if c == true then
			local f = io.open(inv.dir .. "saves.sav", "w")
			f:write(s)
			f:close()
		else
			local x = ""
			for i = 1, table.maxn(inv.inv[id]) + 1, 1 do
				local v = inv.inv[id][i]
				if v then
					x = x .. tostring(v[1]) .. "," .. tostring(v[2]) .. ":"
				else
					x = x .. " :"
				end
			end
			x = us .. ":" .. x .. "\n"
			local f = io.open(inv.dir .. "saves.sav", "a")
			f:write(x)
			f:close()
		end
	end
	inv.inv[id] = {}
	inv.page[id] = 0
	inv.looks[id] = 0
	if inv.items.leave then inv.items.leave(id, r) end
end
addhook([[leave]], [[inv.leave]])