

function table.find(self, value)
	for i, v in ipairs(self) do
		if v == value then
			return true
		end
	end
end

inv.adm = {}
inv.adm.looks = {}
inv.adm.selled = {}

inv.adm.show = function(id, p)
	local s = "Items Page " .. p
	for i = p * 7 - 6, p * 7 do
		if inv.items[i] then
			local v = inv.items[i]
			s = s .. "," .. v.name
		else
			s = s .. ","
		end
	end
	inv.page[id] = p
	menu(id, s .. ",<<<|Back,Next|>>>")
end

inv.adm.showinv = function(pl, id, p)
	local s = "Take items Page " .. p
	for i = p * 7 - 6, p * 7 do
		if inv.inv[id][i] then
			local v = inv.inv[id][i]
			s = s .. "," .. inv.nton(v[1]) .. "|" .. v[2]
		else
			s = s .. ","
		end
	end
	inv.page[pl] = p
	menu(pl, s .. ",<<<|Back,Next|>>>")
end

inv.adm.showplayers = function(id, p)
	local s = "[Administration]Players Page " .. p
	for i = p * 7 - 6, p * 7 do
		if player(i, "exists") then
			s = s .. "," .. player(i, "name")
		else
			s = s .. ","
		end
	end
	inv.page[id] = p
	menu(id, s .. ",<<<|Back,Next|>>>")
end

inv.adm.join = function(id)
	inv.adm.looks[id] = 0
	inv.adm.selled[id] = 0
end

inv.adm.serveraction = function(id, a)
	if a == 3 then
		if inv.admins then
			if table.find(inv.admins, player(id, "usgn")) then
				inv.adm.showplayers(id, 1)
				inv.looks[id] = 0
			end
		else
			inv.adm.showplayers(id, 1)
			inv.looks[id] = 0
		end
	end
end

inv.adm.menu = function(id, men, sel)
	inv.adm.looks[id] = inv.adm.looks[id] or 0
	if men == "[Administration]Players Page " .. inv.page[id] then
		if inv.looks[id] == 0 then
			if sel == 8 then
				if inv.page[id] > 1 then
					inv.adm.showplayers(id, inv.page[id] - 1)
				else
					inv.adm.showplayers(id, 5)
				end
			elseif sel == 9 then
				if inv.page[id] < 5 then
					inv.adm.showplayers(id, inv.page[id] + 1)
				else
					inv.adm.showplayers(id, 1)
				end
			elseif type(sel) == "number" and sel > 0 then
				local pl = sel + inv.page[id] * 7 - 7
				inv.adm.looks[id] = pl
				menu(id, player(pl, "name") .. [[ Administration,Give items,Take items]])
			end
		end
	elseif men == [[Items Page ]] .. inv.page[id] then
		if sel == 8 then
			if inv.page[id] > 1 then
				inv.adm.show(id, inv.page[id] - 1)
			else
				inv.adm.show(id, 1)
			end
		elseif sel == 9 then
			inv.adm.show(id, inv.page[id] + 1)
		elseif type(sel) == "number" and sel > 0 then
			inv.looks[id] = sel + inv.page[id] * 7 - 7
			inv.adm.selled[id] = 0
			menu(id, [[Number,1,2,5,10,20,50,100,200,500]])
			return
		end
	elseif men == [[Number]] then
		if sel > 0 and type(sel) == "number" then
			if inv.adm.selled[id] == 0 then
				local c = {1, 2, 5, 10, 20, 50, 100, 200, 500}
				inv.place(inv.adm.looks[id], inv.looks[id], c[sel])
				msg2(id, "000238118" .. c[sel] .. " of item \"" .. inv.items[inv.looks[id]].name .. "\" were given to " .. player(inv.adm.looks[id], "name") .. ".")
			else
				local c = {1, 2, 5, 10, 20, 50, 100, 200}
				if sel == 9 then
					msg2(id, "000238118All of item \"" .. inv.items[inv.inv[inv.adm.looks[id]][inv.looks[id]][1]].name .. "\" were taken from " .. player(inv.adm.looks[id], "name") .. ".")
					inv.inv[inv.adm.looks[id]][inv.looks[id]] = nil
				else
					msg2(id, "000238118" .. c[sel] .. " of item \"" .. inv.items[inv.inv[inv.adm.looks[id]][inv.looks[id]][1]].name .. "\" were taken from " .. player(inv.adm.looks[id], "name") .. ".")
					if inv.inv[inv.adm.looks[id]][inv.looks[id]][2] > c[sel] then
						inv.inv[inv.adm.looks[id]][inv.looks[id]][2] = inv.inv[inv.adm.looks[id]][inv.looks[id]][2] - c[sel]
					else
						inv.inv[inv.adm.looks[id]][inv.looks[id]] = nil
					end
				end
			end
		end
	elseif men == [[Take items Page ]] .. inv.page[id] then
		if sel == 8 then
			if inv.page[id] > 1 then
				inv.adm.showinv(id, inv.adm.looks[id], inv.page[id] - 1)
			else
				inv.adm.showinv(id, inv.adm.looks[id], inv.page[id])
			end
		elseif sel == 9 then
			inv.adm.showinv(id, inv.adm.looks[id], inv.page[id] + 1)
		elseif type(sel) == "number" and sel > 0 then
			local l = sel + inv.page[id] * 7 - 7
			inv.looks[id] = l
			inv.adm.selled[id] = 1
			menu(id, [[Number,1,2,5,10,20,50,100,200,All]])
		end
	end
	if inv.adm.looks[id] ~= 0 then
		if men == player(inv.adm.looks[id], "name") .. [[ Administration]] then
			if sel == 1 then
				inv.adm.show(id, 1)
			elseif sel == 2 then
				inv.adm.showinv(id, inv.adm.looks[id], 1)
			end
		end
	end
end